-- (C) Copyright International Business Machines Corporation 23 January 
-- 1990.  All Rights Reserved. 
--  
-- See the file USERAGREEMENT distributed with this software for full 
-- terms and conditions of use. 
-- File: min_time.p
-- Author: Arthur P. Goldberg

-- a call
-- call min_time ( Input_Time_Value_1, Input_Time_Value_2, Output_Time_Value );

-- Output_Time_Value = the larger time value

min_time : USING( times, terminalIO )

PROCESS ( Call_Port : Time_Value_Call2_Return1_INTFACE_Receiver )
	DECLARE
		TCM : Time_Value_Call2_Return1_INTFACE;
	BEGIN
		RECEIVE TCM FROM Call_Port;
		-- print charstring # "On entry to Time_Value_Min TCM: ";
		-- print TCM;

		if ( TCM.Input_Time_Value_1 = TCM.Input_Time_Value_2 ) then
			TCM.Output_Time_Value := TCM.Input_Time_Value_1;
			exit done;
		end if;

		if ( case of TCM.Input_Time_Value_1 = 'An_Infinity' ) then
			reveal TCM.Input_Time_Value_1.The_Infinity;
			if ( TCM.Input_Time_Value_1.The_Infinity = 'Neg_Inf' ) then
				TCM.Output_Time_Value := TCM.Input_Time_Value_1;
			else
				-- Input_Time_Value_1 is 'Pos_Inf'
				TCM.Output_Time_Value := TCM.Input_Time_Value_2;
			end if;
			exit done;
		end if;

		if ( case of TCM.Input_Time_Value_2 = 'An_Infinity' ) then
			reveal TCM.Input_Time_Value_2.The_Infinity;
			if ( TCM.Input_Time_Value_2.The_Infinity = 'Neg_Inf' ) then
				TCM.Output_Time_Value := TCM.Input_Time_Value_2;
			else
				-- Input_Time_Value_2 is 'Pos_Inf'
				TCM.Output_Time_Value := TCM.Input_Time_Value_1;
			end if;
			exit done;
		end if;

		-- Both Input_Time_Value_1 and Input_Time_Value_2 are 'Actual'
		if ( case of TCM.Input_Time_Value_1 = 'Actual' and 
			case of TCM.Input_Time_Value_2 = 'Actual' ) then
			reveal TCM.Input_Time_Value_1.The_Actual_Time;
			reveal TCM.Input_Time_Value_2.The_Actual_Time;
			if ( TCM.Input_Time_Value_1.The_Actual_Time > TCM.Input_Time_Value_2.The_Actual_Time ) then
				TCM.Output_Time_Value := TCM.Input_Time_Value_2;
			else
				TCM.Output_Time_Value := TCM.Input_Time_Value_1;
			end if;
			exit done;
		end if;

		on exit (done)
			return TCM;
end process
